
//========================================
//Created by: Eisen Lewis Sy
//Date: 05-28-12
//This is for APLIMAT class
//Game Design and Development Program
//========================================

//Include directives
#include<stdio.h>
#include"GlutStarter.h"

//Function definitions
//=========================================================================
//												void ghDefaultReshapeFunc()
//=========================================================================
void DefaultReshapeFunc(int width, int height)
{
	if (height == 0)
		height = 1;

	double ratio = 1.0 * width / height;
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glViewport(0, 0, width, height);
	gluPerspective(45.0, ratio, 0.1, 5000);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(0.0, 0.0, 20.0,		//Camera position
				0.0, 0.0, 0.0,		//Look point
				0.0, 1.0, 0.0);	//Up vector

	return;
}

//=========================================================================
//														void ghQuickInit()
//=========================================================================
void StartGlut(int* argc,
			char** argv,
			const char* WindowTitle,
			void (*DisplayFunc)(void),
			void (*IdleFunc)(void),
			void (*KeyboardFunc)(unsigned char key, int x, int y),
			void (*KeyboardUpFunc)(unsigned char key, int x, int y),
			void (*SpecialFunc)(int key, int x, int y),
			void (*SpecialUpFunc)(int key, int x, int y),
			void (*MouseFunc)(int button, int state, int x, int y),
			void (*MotionFunc)(int x, int y),
			void (*PassiveMotionFunc)(int x, int y),
			void (*EntryFunc)(int state),
			void (*ReshapeFunc)(int width, int height),
			int PosX,
			int PosY,
			int Width,
			int Height,
			int DisplayMode)
{
	//Initialization
	glutInit(argc, argv);
	glutInitDisplayMode(DisplayMode);
	glutInitWindowPosition(PosX, PosY);
	glutInitWindowSize(Width, Height);
	glutCreateWindow(WindowTitle);

	//Register display functions
	glutDisplayFunc(DisplayFunc);
	glutIdleFunc(IdleFunc);
	glutReshapeFunc(ReshapeFunc);

	//Register input functions
	glutKeyboardFunc(KeyboardFunc);
	glutKeyboardUpFunc(KeyboardUpFunc);
	glutSpecialFunc(SpecialFunc);
	glutSpecialUpFunc(SpecialUpFunc);

	//Register mouse functions
	glutMouseFunc(MouseFunc);
	glutMotionFunc(MotionFunc);
	glutPassiveMotionFunc(PassiveMotionFunc);
	glutEntryFunc(EntryFunc);

	glutMainLoop();

	return;
}