#ifndef __SYEL_VECTOR3_H__
#define __SYEL_VECTOR3_H__

#include <stdio.h>
#include <math.h>

namespace Aplimat
{
	namespace VectorMath
	{
		class Vector3
		{
		public:
			Vector3();
			Vector3(float x, float y, float z);
			~Vector3();
			
			Vector3 &operator=(const Vector3 &rhs);

			Vector3 &operator+=(const Vector3 &rhs);
			Vector3 operator+(const Vector3 &op);

			Vector3 &operator-=(const Vector3 &rhs);
			Vector3 operator-(const Vector3 &op);

			Vector3 &operator*=(const float scalar);
			Vector3 operator*(const float scalar);

			float GetLength();
			void Normalize();
			Vector3 Normalized();

			void PrintLine();

			float X;
			float Y;
			float Z;
		protected:
		private:
		};
	}
}

#endif